/*                                                           
Cookie.cc
*/

#include "Cookie.h"

Cookie::Cookie(char *user)
  {
  newCookie();
  setSecure(false); 
  setName(user);
  setValue((char *)thecookie.cstr()); 
  setDomain(""); 
  setPath("");   
  }

Cookie::~Cookie()
  {
  }

void Cookie::newCookie ()
  {
  char cookie_chars[] = ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789");
  int i, p;
  char rawid[24 + 1], letra[2];
  TSBuffer abuf;
  
  letra[1] = '\0';
  initStr (rawid);
  for (i = 1; i <= 24; ++i)
    {
    p = (int) Rand(62);
    letra[0] = cookie_chars[p];
    strcat (rawid, letra);
    }
  strcpy (abuf, rawid);  
  thecookie = XString (abuf);        
  }

char *Cookie::getSetFullCookieLine() const
  {
  XString acook;  
  acook =  XString(getName()); acook += '='; acook += getValue();
  if(fPath.empty() == false) {acook += "; Path="; acook += fPath;}  
  if(fDomain.empty() == false)  {acook += "; Domain="; acook += fDomain;}  
//  acook += "; Expires=Wednesday, 22-Nov-20 09:09:00 GMT";
  if(fSecure == true) {acook += "; Secure";}
  acook += "; Version=1";
  return xstrdup ((char *)acook.cstr());
  }

char *Cookie::getSetClearFullCookieLine() const
  {
  XString acook;  
  acook =  XString(getName()); acook += '='; acook += getValue();
  if(fPath.empty() == false) {acook += "; Path="; acook += fPath;}  
  if(fDomain.empty() == false)  {acook += "; Domain="; acook += fDomain;}  
  acook += "; Expires=Wednesday, 22-Nov-00 09:09:00 GMT";
  if(fSecure == true) {acook += "; Secure";}
  acook += "; Version=1";
  return xstrdup ((char *)acook.cstr());
  }

char *Cookie::getName() const 
  { 
  return (char *)fName.cstr(); 
  }

char *Cookie::getValue() const 
  { 
  return (char *)fValue.cstr(); 
  }

char *Cookie::getDomain() const 
  { 
  return (char *)fDomain.cstr(); 
  }

char *Cookie::getPath() const 
  { 
  return (char *)fPath.cstr(); 
  }    

bool Cookie::isSecure() const 
  { 
  return fSecure; 
  }

void Cookie::setName(const char *name) 
  { 
  fName = XString (name); 
  }

void Cookie::setValue(const char *value) 
  { 
  fValue = XString (value); 
  }

void Cookie::setDomain(const char *domain) 
  { 
  fDomain = XString (domain); 
  }

void Cookie::setPath(const char *path) 
  { 
  fPath = XString (path); 
  }

void Cookie::setSecure(bool secure) 
  { 
  fSecure = secure; 
  }
  
  

